	program beta_match
C======================================================================= 
C         Author : Bart Faatz 
C         Company: DESY/HASYLAB 
C         Date   : May 14, 2004 
C         Version: 0.5
C         Filename: beta-match2.f
C 
C======================================================================= 
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      INCLUDE  'magnet.cmn'
	INCLUDE  'sim.cmn'
c
	REAL*8 MATRIX(2,2)
 	REAL*8 C, S, C_p, S_p, CH, SH, CH_p, SH_p
 	REAL*8 beta_x0, beta_y0, alpha_x0, alpha_y0
	REAL*8 zstop0, awx0, awy0, delaw0, qfdx0, qfdy0
 	INTEGER I, ierr1, ierr2, iseed0
	INTEGER ierr, nout
c
      ierr = READIN()
      call chk_input                     !make input consistent
c
c Copy parameters that should not be changed in the input file
c
	iseed0 = iseed
	zstop0 = zstop
	awx0 = awx
	awy0 = awy
	delaw0 = delaw
	qfdx0 = qfdx
	qfdy0 = qfdy
	zstop = -1
	awx = 0
	awy = 0
	delaw = 0
	qfdx = 0
	qfdy = 0
c
      xkw0 = twopi/xlamd
      call magfield(xkw0,0)
c
	beta_x0 = 0.D0
	beta_y0 = 0.D0
	alpha_x0 = 0.D0
	alpha_y0 = 0.D0
c 
c transfer matrix in the x-direction: 1.0 for hor. foc. 
c
 	CALL CS2(QFLD,NSTEPZ,GAMMA0,MATRIX,1.D0,UNITLENGTH,XKX*xkw0**2,AWZ)
	C = MATRIX(1,1)
 	S = MATRIX(1,2)
 	C_p = MATRIX(2,1)
 	S_p = MATRIX(2,2)
 	IF((ABS(S).GT.tiny).AND.(ABS(S_p).GT.tiny)) THEN
		IF(ABS(C-S_p).GT.tiny) THEN 
			beta_x0 = 4*S**2/(4-(C+S_p)**2)
                  IF(beta_x0.GT.0.) THEN 
                     beta_x0 = SQRT(beta_x0)
                     ELSE
                     WRITE(*,*)'beta_x0 imaginary '
                  ENDIF
			alpha_x0 = (C-S_p)*beta_x0/(2*S)
		ELSE
			beta_x0 = -S*S_p/(C*C_p)
                  IF(beta_x0.GT.0.) THEN 
                     beta_x0 = SQRT(beta_x0)
                     ELSE
                     WRITE(*,*)'beta_x0 imaginary '
                  ENDIF
			alpha_x0 = 0.
		ENDIF
		ELSE
		write(*,*) 'S or S_p too small: structure not periodic?'
	ENDIF
C
c transfer matrix in the y-direction: -1.0 for vert. foc. 
c
 	CALL CS2(QFLD,NSTEPZ,GAMMA0,MATRIX,-1.D0,UNITLENGTH,XKY*xkw0**2,AWZ)
	CH = MATRIX(1,1)
 	SH = MATRIX(1,2)
 	CH_p = MATRIX(2,1)
 	SH_p = MATRIX(2,2)
 	IF((ABS(SH).GT.tiny).AND.(ABS(SH_p).GT.tiny)) THEN
		IF(ABS(CH-SH_p).GT.tiny) THEN 
			beta_y0 = 4*SH**2/(4-(CH+SH_p)**2)
                  IF(beta_y0.GT.0.) THEN 
                     beta_y0 = SQRT(beta_y0)
                     ELSE
                     WRITE(*,*)'beta_y0 imaginary '
                  ENDIF
			alpha_y0 = (CH-SH_p)*beta_y0/(2*SH)
		ELSE
			beta_y0 = -SH*SH_p/(CH*CH_p)
                  IF(beta_y0.GT.0.) THEN 
                     beta_y0 = SQRT(beta_y0)
                     ELSE
                     WRITE(*,*)'beta_y0 imaginary '
                  ENDIF
			alpha_y0 = 0.
		ENDIF
		ELSE
		write(*,*) 'SH or SH_p too small: structure not periodic?'
	ENDIF
      RXBEAM = SQRT(beta_x0*emitx/GAMMA0)
      ALPHAX = alpha_x0

      RYBEAM = SQRT(beta_y0*emity/GAMMA0)
      ALPHAY = alpha_y0
      write(*,*) ' Matched file saved as "TEMPLATE.IN"'
	iseed = iseed0
	zstop = zstop0
	awx = awx0
	awy = awy0
	delaw = delaw0
	qfdx = qfdx0
	qfdy = qfdy0
      ierr1 = -3
cbart      ierr2=openoutputfile(ierr1,'qwe.matched')   !open outputfile+dump namelist
      ierr2=openoutputfile(ierr1)   !open outputfile+dump namelist


      STOP
C
  10  Format('PLEASE ENTER INPUT FILE NAME ',/,
     f        'Magnetic Field Description')
  20  Format(a30)
	end

  	SUBROUTINE CS2(QFLD,NSTEPZ,GAMMA0,MATRIX,SIGN,LENGTH,KXY,AW)
C======================================================================= 
C         Author : Bart Faatz 
C         Company: DESY/HASYLAB 
C         Date   : 24-01-04 
C         Version: 1.0 
C         Filename: CS2.SUB 
C
C This subroutine calculates from quad strength and length and the undulator 
C focusing the total C, S, C_p and S_p functions for a focusing structure. 
C This information can later be used to calculate matching beta and alpha.
C=======================================================================
	implicit none
	REAL*8 QFLD(*), AW(*), KXY, GAMMA0, MATRIX(2,2)
	REAL*8 MATRIX2(2,2), K, phi, L, tiny, SIGN, LENGTH, betpar0
	INTEGER NSTEPZ, I
	tiny = 1.D-6
	MATRIX(1,1) = 1.D0
	MATRIX(1,2) = 0.D0 
	MATRIX(2,1) = 0.D0 
	MATRIX(2,2) = 1.D0 
	DO I=1,NSTEPZ
      betpar0=1.+aw(i)**2                ! add weak focusing
      betpar0=dsqrt(1.d0-betpar0/gamma0/gamma0)
		K = KXY*(AW(I)/GAMMA0/betpar0)**2+SIGN*QFLD(I)/GAMMA0/betpar0
		L = LENGTH
		phi = SQRT(ABS(K))*L
		IF(K.GT.tiny) THEN 
			MATRIX2(1,1) = COS(phi) 
			MATRIX2(1,2) = SIN(phi)/SQRT(K) 
			MATRIX2(2,1) = -SQRT(K)*SIN(phi) 
			MATRIX2(2,2) = COS(phi) 
		ELSE 
			MATRIX2(1,1) = COSH(phi) 
			IF(ABS(K).LT.tiny) THEN 
				MATRIX2(1,2) = L 
			ELSE 
				MATRIX2(1,2) = SINH(phi)/SQRT(ABS(K)) 
			ENDIF 
			MATRIX2(2,1) = SQRT(ABS(K))*SINH(phi) 
			MATRIX2(2,2) = COSH(phi) 
		ENDIF 
		CALL MMM(MATRIX2,MATRIX,2) 
	END DO 

	RETURN
	END
C
      SUBROUTINE MMM(MATRIX1,MATRIX2,N) 
C======================================================================= 
C         Author : Bart Faatz 
C         Company: DESY/HASYLAB 
C         Date   : 18-11-96 
C         Version: 1.0 
C         Filename: MMM.SUB 
C 
C This subroutine calculates MATRIX3_ij = MATRIX1_ik MATRIX2_kj,  
C where MATRIX1 and MATRIX2 are  N by N matrices 
C The result is written in MATRIX2 
C 
C----------------------------------------------------------------------- 
C 
      INTEGER NMAX 
      PARAMETER(NMAX=5) 
      REAL*8 MATRIX1(N,N), MATRIX2(N,N), MATRIX3(NMAX,NMAX) 
      INTEGER N,I,J 
C 
      IF(N.GT.NMAX) THEN 
        WRITE(*,*) 'Arraysize larger than 5 (routine MMM.SUB)' 
        STOP 
      ENDIF 
C 
      DO 10 I=1,N 
        DO 20 J=1,N 
          MATRIX3(I,J) = 0. 
          DO 30 K=1,N 
            MATRIX3(I,J) = MATRIX3(I,J)+MATRIX1(I,K)*MATRIX2(K,J) 
 30       CONTINUE 
 20     CONTINUE 
 10   CONTINUE 
C 
      DO 40 I=1,N 
        DO 50 J=1,N 
          MATRIX2(I,J) = MATRIX3(I,J) 
 50     CONTINUE 
 40   CONTINUE 
C 
      RETURN 
      END 
C 
      include 'magfield.f'
      include "string.f"
      include "math.f"
cbart      include "parms.f"
      include "varia.f"
      include "input-red.f"
      include "check.f"
c
c time.cmn needed in chk_bnd needs SPACE
c

